//
//  GifCellNode.m
//  TextureGifMemoryBug
//
//  Created by David Blake on 29/9/17.
//  Copyright © 2017 davidblake. All rights reserved.
//

#import "GifCellNode.h"
#import "FLAnimatedImageView.h"
#import "FLAnimatedImage.h"

@implementation GifCellNode



- (instancetype)initWithFLImage:(BOOL)displayFL
{
    self = [super init];
    
    if (self) {
        
        self.showFLNode = displayFL;
        
        self.backgroundColor = [UIColor lightGrayColor];
        
        self.gifUrl = [NSURL URLWithString:@"https://media2.giphy.com/media/l378y4jWZfNFZXbdm/giphy.gif"];
        
        self.imageNode = [[ASNetworkImageNode alloc] init];
        
        self.flImageNode = [[ASDisplayNode alloc] initWithViewBlock:^{
            FLAnimatedImageView* flImageView = [[FLAnimatedImageView alloc] init];
            return flImageView;
        }];
        
        self.editableTextNode = [[ASEditableTextNode alloc] init];
        
        self.automaticallyManagesSubnodes = YES;
        
    }
    
    return self;
}

-(void)loadGif
{
    self.imageNode.URL = self.gifUrl;
    
    return;
    
    NSString *str = [[NSBundle mainBundle] pathForResource:@"giphyrunning" ofType:@"gif"];
    NSData *fileData = [NSData dataWithContentsOfFile:str];

    if (!_showFLNode) {
        
        id<ASAnimatedImageProtocol> asAnimatedImage = [[ASPINRemoteImageDownloader sharedDownloader] animatedImageWithData:fileData];
        self.imageNode.animatedImage = asAnimatedImage;

    }
    else {
        FLAnimatedImage *flimage = [FLAnimatedImage animatedImageWithGIFData:fileData];
        FLAnimatedImageView* flImageView = (FLAnimatedImageView*)self.flImageNode.view;
        flImageView.animatedImage = flimage;
    }
}

- (ASLayoutSpec *)layoutSpecThatFits:(ASSizeRange)constrainedSize
{
    //return [ASWrapperLayoutSpec wrapperWithLayoutElement:self.editableTextNode]; //Unblock this to cause crash
    
    CGFloat screenWidth = constrainedSize.max.width;
    ASDisplayNode* showNode = !_showFLNode ? self.imageNode : self.flImageNode;
    showNode.style.preferredSize = CGSizeMake(screenWidth,screenWidth);
    return [ASWrapperLayoutSpec wrapperWithLayoutElement:showNode];
}

-(void)didEnterPreloadState
{
    [super didEnterPreloadState];
    
    [self loadGif];
    
}

-(void)didExitPreloadState
{
    [super didExitPreloadState];
    
    
     //This has no affect anyway, but blocking off as you probably want to memory release in default conditions
    if (!self.showFLNode) {
        if (self.imageNode.animatedImage) {
            self.imageNode.animatedImage = nil;
        }
    }
    else {
        FLAnimatedImageView* flImageView = (FLAnimatedImageView*)self.flImageNode.view;
        if (flImageView.animatedImage) {
            flImageView.animatedImage = nil;
        } 
    }
    
}


@end
