//
//  ViewController.m
//  TextureGifMemoryBug
//
//  Created by David Blake on 29/9/17.
//  Copyright © 2017 davidblake. All rights reserved.
//

#import "ViewController.h"
#import "GifCellNode.h"
#import <PINCache/PINCache.h>
#import "PINRemoteImageManager.h"

@interface ViewController ()

@end

@implementation ViewController



- (instancetype)init{
    ASDisplayNode* node = [[ASDisplayNode alloc] init];
    
    if (!(self = [super initWithNode:node])) return nil; //ASync VC
    
    UICollectionViewFlowLayout *layout = [[UICollectionViewFlowLayout alloc] init];
    layout.minimumLineSpacing  = 20;
    
    self.collectionNode = [[ASCollectionNode alloc] initWithCollectionViewLayout:layout];
    self.collectionNode.delegate = self;
    self.collectionNode.dataSource = self;
    //self.collectionNode.backgroundColor = [UIColor blueColor];
       
    [node addSubnode:self.collectionNode];
    
  

    UINavigationItem *newItem = [self navigationItem];
    UIBarButtonItem* clearButton = [[UIBarButtonItem alloc] initWithTitle:@"ClearMem" style:UIBarButtonItemStyleDone target:self action:@selector(clearMemory)];
    [newItem setRightBarButtonItem: clearButton];
    
    
    UIBarButtonItem* switchTypesButton = [[UIBarButtonItem alloc] initWithTitle:@"Switch" style:UIBarButtonItemStyleDone target:self action:@selector(switchTypes)];
    [newItem setLeftBarButtonItem: switchTypesButton];

    [self displayFLNode:NO];
    
    return self;
}

-(void)clearMemory
{
    NSLog(@"clearing memory!");
    PINCache* cache = (PINCache*)[[[ASPINRemoteImageDownloader sharedDownloader] sharedPINRemoteImageManager] cache];
    [cache removeAllObjects];

}

-(void)switchTypes
{
    [self displayFLNode:!_showFLView];
}

-(void)displayFLNode:(BOOL)displayFL
{
    self.showFLView = displayFL;
    [self.collectionNode reloadData];
    
    self.title = self.showFLView ? @"FLImageView" : @"ASImageNode";
    self.collectionNode.backgroundColor = !self.showFLView ? [UIColor whiteColor] : [UIColor yellowColor];
}

- (void)viewWillLayoutSubviews
{
    _collectionNode.frame = self.node.bounds;

}

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view, typically from a nib.
}


- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}




#pragma mark - ASCollectionView Delegate


#pragma mark - ASCollectionView Data Source

- (ASCellNodeBlock)collectionNode:(ASCollectionNode *)collectionNode nodeBlockForItemAtIndexPath:(NSIndexPath *)indexPath
{
    
    ASCellNode *(^nodeBlock)() = nil;
    
    BOOL showFL = _showFLView;
    nodeBlock = ^{
        
        GifCellNode *cellNode = [[GifCellNode alloc] initWithFLImage:showFL];
        
        if (cellNode == nil) {
            NSAssert(cellNode == nil,@"collection node cell == nil!!");
        }
        
        return cellNode;
    };
    
    return nodeBlock;
}


- (NSInteger)collectionNode:(ASCollectionNode *)collectionNode numberOfItemsInSection:(NSInteger)section
{
    return 1000;
}

- (NSInteger)numberOfSectionsInCollectionNode:(ASCollectionNode *)collectionNode
{
    return 1;
}

- (void)collectionNode:(ASCollectionNode *)collectionNode willBeginBatchFetchWithContext:(ASBatchContext *)context
{
      
}

- (BOOL)shouldBatchFetchForCollectionNode:(ASCollectionNode *)collectionNode
{
    return NO;
}


@end
